=== debian/changelog ===
papi (7.0.1-1) unstable; urgency=medium

  * New upstream release.
  * Update upstream URLs.
  * Refresh patches.
  * Bump libpfm4-dev B-D to >= 4.12.1+git19.

 -- Andreas Beckmann <anbe@debian.org>  Fri, 18 Aug 2023 09:02:38 +0200
